//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Aqua
#property indicator_color2  Magenta
#property indicator_color3  Aqua
#property indicator_color4  Magenta
#property indicator_color5  Aqua
#property indicator_color6  Magenta

//
//
//
//
//
//

extern int    ChannelPeriod = 9;
extern double Risk          = 0.30;

//
//
//
//
//
//

double UpSign[];
double DnSign[];
double UpStop[];
double DnStop[];
double UpLine[];
double DnLine[];
double bsmax[];
double bsmin[];
double trend[];

//+------------------------------------------------------------------+
//|                        
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,UpSign); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,108); 
   SetIndexBuffer(1,DnSign); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,108); 
   SetIndexBuffer(2,UpStop); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159); 
   SetIndexBuffer(3,DnStop); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159); 
   SetIndexBuffer(4,UpLine);                                                
   SetIndexBuffer(5,DnLine);                                                  
   SetIndexBuffer(6,bsmax);
   SetIndexBuffer(7,bsmin);                                                   
   
 
   IndicatorShortName("PriceChannel_Stop_v1("+ChannelPeriod+")");
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      double hi = High[i]; for(k=1; k<ChannelPeriod && (i+k)>=0; k++) hi = MathMax(hi,High[i+k]);
      double lo = Low[i];  for(k=1; k<ChannelPeriod && (i+k)>=0; k++) lo = MathMin(lo, Low[i+k]);
     
      bsmax[i]=hi-(hi-lo)*Risk;
	   bsmin[i]=lo+(hi-lo)*Risk;
	   
      UpSign[i] = EMPTY_VALUE;
      DnSign[i] = EMPTY_VALUE;
      UpLine[i] = EMPTY_VALUE;
      DnLine[i] = EMPTY_VALUE;
      trend[r]  = trend[r-1]; 
      
      //
      //
      //
      //
      //
      
      if (Close[i]>bsmax[i+1])  trend[r] = 1; 
	   if (Close[i]<bsmin[i+1])  trend[r] =-1;
		  		
	   if(trend[r]>0 && bsmin[i]<bsmin[i+1]) bsmin[i]=bsmin[i+1];
	   if(trend[r]<0 && bsmax[i]>bsmax[i+1]) bsmax[i]=bsmax[i+1];
	  
	   if (trend[r] == 1) 
	   {
	     UpLine[i]=bsmin[i]; UpStop[i]=bsmin[i];   if (trend[r-1]!= 1) UpSign[i] = UpLine[i];
	     
	   }
	   if (trend[r] ==-1) 
	   {
	     DnLine[i]=bsmax[i]; DnStop[i]=bsmax[i];  if (trend[r-1]!=-1) DnSign[i] = DnLine[i];
	     
	   }
	 
   }
   return(0);
  }
//+------------------------------------------------------------------+